/* LBmobile.c  */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <sys/wait.h>
#include <pthread.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include "Util.h"
#include "VoIPpkt.h"

/* #define VICDEBUG */

#define P(X) do { fprintf(stderr,X "\n"); fflush(stderr); } while(0)

typedef struct {
	uint16_t port_number;
	int attivo;
} UDPdest;
UDPdest udpdest[MAXNUMCONNECTIONS];

fd_set rdset, all;
int maxfd;
int numspediti=0;
int numscartati=0;
int printed=0;

void sig_print(int signo)
{
	if(printed==0)
	{
		printed=1;
		if(signo==SIGINT)		printf("SIGINT\n");
		else if(signo==SIGHUP)	printf("SIGHUP\n");
		else if(signo==SIGTERM)	printf("SIGTERM\n");
		else					printf("other signo\n");
		printf("\n");
		/*
		for(i=0;i<MAXNUMCONNECTIONS;i++)
		{
			printf("canale %d: sent %d received %d  tot %d\n",
					i, Ricevuti[i][0],Ricevuti[i][1], Ricevuti[i][0]+Ricevuti[i][1] );
		}
		*/
		printf("numspediti %d  numscartati %d\n", numspediti, numscartati );
		fflush(stdout);
	}
	exit(0);
	return;
}

void stampa_fd_set(char *str, fd_set *pset)
{
	int i;
	printf("%s ",str);
	for(i=0;i<100;i++) if(FD_ISSET(i,pset)) printf("%d ", i);
;	printf("\n");
}

int	RecvCfg(int monitorfd, uint32_t *pnumporte, uint16_t porte[] )
{
	char ch; int i, ris;
	
	fprintf(stderr,"RecvCfg starts\n");
	/* ris=recv(monitorfd,buf,65536,MSG_DONTWAIT); */
	ris=recv(monitorfd,&ch,1,0);
	if(ris!=1) { fprintf(stderr,"RecvCfg failed: "); exit(9); }
	printf("ricevo dal monitor: %c\n", ch);
	fflush(stdout);
	if(ch=='C') {
		ris=recv(monitorfd,pnumporte,sizeof(uint32_t),0);
		if(ris!=sizeof(uint32_t)) { fprintf(stderr,"RecvCfg recv_configurazione failed: "); exit(9); }
		printf("ricevo dal monitor: num porte %u\n", *pnumporte );
		fflush(stdout);
		for(i=0;i<*pnumporte;i++) {
			ris=recv(monitorfd,&(porte[i]),sizeof(uint16_t),0);
			if(ris!=sizeof(uint16_t)) { fprintf(stderr,"RecvCfg recv_configurazione failed: "); exit(9); }
			fprintf(stderr,"ricevo dal monitor: porta %d\n", (uint16_t)porte[i] );
			fflush(stderr);
		}
		fprintf(stderr,"RecvCfg terminated correctly\n");
		fflush(stderr);
		return(1);	
	}
	fprintf(stderr,"RecvCfg receive wrong char: failed: ");
	exit(9);
	return(0);	
}

int send_udp(uint32_t socketfd, char *buf, uint32_t len, uint16_t port_number_local, char *IPaddr, uint16_t port_number_dest)
{
	int ris;
	struct sockaddr_in To;
	int addr_size;

	/* assign our destination address */
	memset( (char*)&To,0,sizeof(To));
	To.sin_family		=	AF_INET;
	To.sin_addr.s_addr  =	inet_addr(IPaddr);
	To.sin_port			=	htons(port_number_dest);

	addr_size = sizeof(struct sockaddr_in);
	/* send to the address */
	ris = sendto(socketfd, buf, len , MSG_NOSIGNAL, (struct sockaddr*)&To, addr_size);
	if (ris < 0) {
		printf ("sendto() failed, Error: %d \"%s\"\n", errno,strerror(errno));
		return(0);
	}
	return(ris);
}

void setup_new_configurazione(uint32_t *pnumporte, uint16_t *vporte, uint32_t *pnewnumporte, uint16_t *newvporte)
{
	int i;
	/* copio la nuova configurazione */
	*pnumporte=*pnewnumporte;
	for(i=0;i<*pnumporte;i++) {
		udpdest[i].attivo=1;
		udpdest[i].port_number=vporte[i]=newvporte[i];
	}
	for(i=*pnumporte;i<MAXNUMCONNECTIONS;i++) {
		udpdest[i].attivo=0;
		vporte[i]=0;
	}
}

long int compute_delay(uint32_t *buf)
{
	struct timeval sent, now, tempoimpiegato;
	uint32_t idmsg;
	long int msec;

	idmsg=buf[0];
	memcpy( (char*)&sent, (char*)&(buf[1]), sizeof(struct timeval) );
	gettimeofday(&now,NULL);
	/*
	fprintf( f,	"\nsent: %lu : %ld sec %ld usec\n", idmsg, sent.tv_sec, sent.tv_usec );
	fprintf( f,	"now:  %lu : %ld sec %ld usec\n", idmsg, now.tv_sec, now.tv_usec );
	*/
	tempoimpiegato=differenza(now,sent);
	msec=(tempoimpiegato.tv_sec*1000)+(tempoimpiegato.tv_usec/1000);
	/*
	fprintf(	f, "tempoimpiegato: %lu : %ld sec %ld usec\n\n", 
			idmsg, tempoimpiegato.tv_sec, tempoimpiegato.tv_usec );
	*/
	return(msec);
}


#define PARAMETRIDEFAULT "./LBmobile.exe 6001 7001 8000"
void usage(void) 
{  printf ( "usage:  ./LBmobile.exe LOCALPORTMOBILE LOCALPORTDATA PORTMONITOR\n"
			"esempio: "  PARAMETRIDEFAULT "\n");
}

int main(int argc, char *argv[])
{
	uint16_t portmonitor, localportfrommobile, localportdatamonitor;
	uint32_t numporte;
	uint16_t porte[MAXNUMCONNECTIONS];
	struct sockaddr_in Cli;
	unsigned int len;
	int32_t monitordatafd;
	int i, ris, listening_mobilefd, appmobilefd, monitorfd;

	printf ("uso i parametri di default \n%s\n", PARAMETRIDEFAULT );
	localportfrommobile = 6001;
	localportdatamonitor = 7001;
	portmonitor = 8000;

	for(i=0;i<MAXNUMCONNECTIONS;i++) udpdest[i].attivo=0;

	init_random();
	/* mi connetto al monitor */
	ris=TCP_setup_connection(&monitorfd, "127.0.0.1", portmonitor,  300000, 300000, 1);
	if(!ris) {	printf ("TCP_setup_connection() failed\n"); exit(1); }
	else printf("monitorfd %d\n", monitorfd);

	FD_ZERO(&all);
	FD_SET(monitorfd,&all);
	maxfd=monitorfd;

	ris=RecvCfg(monitorfd,&numporte,porte);
	if(!ris) {	printf ("RecvCfg() failed\n"); exit(1); }
	for(i=0;i<numporte;i++) {
		udpdest[i].attivo=1;
		udpdest[i].port_number=porte[i];
	}

	ris=UDP_setup_socket_bound( &monitordatafd, localportdatamonitor, 65535, 65535 );
	if (!ris) {	printf ("UDP_setup_socket_bound() failed\n"); exit(1); }
	FD_SET(monitordatafd,&all);
	if(monitordatafd>maxfd)
		maxfd=monitordatafd;

	appmobilefd=0;
	/* attendo connessione dalla applicazione lato mobile */
	ris=TCP_setup_socket_listening( &listening_mobilefd, localportfrommobile, 300000, 300000, 1);
	if (!ris)
	{	printf ("TCP_setup_socket_listening() failed\n");
		exit(1);
	}
	do { memset (&Cli, 0, sizeof (Cli));		
		len = sizeof (Cli);
		appmobilefd = accept ( listening_mobilefd, (struct sockaddr *) &Cli, &len);
	} while ( (appmobilefd<0) && (errno==EINTR) );
	if (appmobilefd < 0 ) {	
		perror("accept() failed: \n");
		exit (1);
	}
	/* NO NAGLE per i tcp */
	ris=SetsockoptTCPNODELAY(appmobilefd,1); if (!ris) { fprintf(stderr,"unable to setup TCPNODELAY option\n"); exit(5); }

	/* chiusura del socket TCP listening e setup dei socket UDP	*/
	close(listening_mobilefd);
	FD_SET(appmobilefd,&all);
	if(appmobilefd>maxfd)
		maxfd=appmobilefd;

	for(;;)
	{
		do {
			rdset=all;

#ifdef VICDEBUG
			stampa_fd_set("rdset prima",&rdset);
#endif

			ris=select(maxfd+1,&rdset,NULL,NULL,NULL);
		} while( (ris<0) && (errno==EINTR) );
		if(ris<0) {
			perror("select failed: ");
			exit(1);
		}

#ifdef VICDEBUG
		stampa_fd_set("rdset dopo",&rdset);
#endif

		if( FD_ISSET(appmobilefd,&rdset) )
		{
			uint32_t buf[PKTSIZE];
			uint32_t idmsg;

			/* ricevo un pkt */
			ris=Readn(appmobilefd,(char*)buf,PKTSIZE);
			if(ris!=PKTSIZE) { fprintf(stderr,"recv from appmobile failed, received %d: ", ris); exit(9); }

			/* spedisco i pkt sulla prima porta attiva, qualunque sia */
			for(i=0;i<numporte;i++) {
				if(udpdest[i].attivo==1)  {
					idmsg=buf[0];
					ris=send_udp(monitordatafd, (char*)buf, PKTSIZE , 1000, "127.0.0.1", udpdest[i].port_number );
					if(ris)  {
						;
#ifdef VICDEBUG
						struct timeval now;
						gettimeofday(&now,NULL);
						fprintf(stderr,"pkt id %u sent to %d at %ld sec %ld usec\n", idmsg, udpdest[i].port_number,
														now.tv_sec, now.tv_usec );
#endif
						fprintf(stderr,"pkt %u sent to %d\n",idmsg, udpdest[i].port_number);
					}
					else {
						fprintf(stderr,"pkt id %u NOT sent\n", idmsg );
					}
					break;
				}
			}
		}

		/* se arriva qualcosa dalla connessione TCP con il monitor, leggo!!!! */
		if( FD_ISSET(monitorfd,&rdset) )
		{
			char ch; int ris;
			uint32_t tmpnumporte;
			uint16_t tmpporte[MAXNUMCONNECTIONS];
			uint32_t idmsg;

#ifdef VICDEBUG
			fprintf(stderr,"in arrivo qualcosa dalla connessione TCP del monitor:\n");
#endif
			/* ris=recv(monitorfd,buf,65536,MSG_DONTWAIT); */
			ris=recv(monitorfd,&ch,1,0);
			if(ris!=1) { fprintf(stderr,"recv from monitor failed: "); exit(9); }
#ifdef VICDEBUG
			printf("ricevo dal monitor: %c\n",ch);
			fflush(stdout);
#endif
			if(ch=='C') {
				ris=recv(monitorfd,(char*)&tmpnumporte,sizeof(uint32_t),0);
				if(ris!=sizeof(uint32_t)) { fprintf(stderr,"(C)recv_configurazione failed: "); exit(9); }
				printf("ricevo dal monitor: num porte %u\n", tmpnumporte  );
				for(i=0;i<tmpnumporte;i++) {
 					ris=recv(monitorfd,&(tmpporte[i]),sizeof(uint16_t),0);
					if(ris!=sizeof(uint16_t)) { fprintf(stderr,"(C%d)recv_configurazione failed: ",i); exit(9); }
					printf("ricevo dal monitor: porta %d\n", tmpporte[i] );
				}
				setup_new_configurazione(&numporte,porte,&tmpnumporte,tmpporte);
			} else if( ch=='A' ) {
				ris=recv(monitorfd,(char*)&idmsg,sizeof(uint32_t),0);
				if(ris!=sizeof(uint32_t)) { fprintf(stderr,"(A)recv ack failed: "); exit(9); }
				printf("ricevo dal monitor: ACK %u\n", idmsg );
			} else if( ch=='N' ) {
				ris=recv(monitorfd,(char*)&idmsg,sizeof(uint32_t),0);
				if(ris!=sizeof(uint32_t)) { fprintf(stderr,"(N)recv nack failed: "); exit(9); }
				printf("ricevo dal monitor: NACK %u\n", idmsg );
			}
		}

		/* se arriva qualche pacchetto dati UDP dal monitor, leggo!!!! */
		if(FD_ISSET(monitordatafd,&rdset))  {
			uint32_t buf[ (65536/sizeof(uint32_t)) ];
			struct sockaddr_in From;
			unsigned int Fromlen; 
			int ris;

			memset(&From,0,sizeof(From));
			Fromlen=sizeof(struct sockaddr_in);
			ris = recvfrom ( monitordatafd, (char*)buf, (int)65536, 0, (struct sockaddr*)&From, &Fromlen);
			if (ris<0) {
				if(errno!=EINTR) {	
					fprintf(stderr,"recvfrom() failed, Error: %d \"%s\"\n", errno,strerror(errno));
					/*
					close(monitordatafd);
					exit(8);
					*/
					fprintf(stderr,"ma non ho chiuso  il socket");
				}
			}
			else {
				int ris2;
				long int msecdelay;
				uint32_t idletto;
				
				idletto=buf[0];
				msecdelay=compute_delay(buf);
#ifdef OUTPUT_MEDIO
				fprintf(stderr,"LBmobile pkt received size %d id %u delay %ld msec \n", ris, idletto, msecdelay);
#endif
				/* spedisco all'applicazione */
				ris2=Sendn(appmobilefd,(char*)buf,ris);
				if(ris2!=ris) { fprintf(stderr,"recv from appmobile failed, received %d: ", ris); exit(9); }
			}
		}

	} /* fine for ;; */
	close(monitorfd);
	return(0);
}

